var panel = new Panel
var panelScreen = panel.screen
var freeEdges = {"bottom": true, "top": true, "left": true, "right": true}
var isHorizontal = false;
var isVertical = false;

for (i = 0; i < panelIds.length; ++i) {
    var tmpPanel = panelById(panelIds[i])
    if (tmpPanel.screen == panelScreen) {
        // Ignore the new panel
        if (tmpPanel.id != panel.id) {
            freeEdges[tmpPanel.location] = false;
        }
    }
}

if (freeEdges["bottom"] == true) {
    panel.location = "bottom";
} else if (freeEdges["top"] == true) {
    panel.location = "top";
} else if (freeEdges["left"] == true) {
    panel.location = "left";
} else if (freeEdges["right"] == true) {
    panel.location = "right";
} else {
    // There is no free edge, so leave the default value
    panel.location = "top";
}

if (panel.location == "top" || panel.location == "bottom") {
    // Horizontal
    isHorizontal = true;
    panel.height = gridUnit * 2
} else {
    // Vertical
    isVertical = true;
    panel.height = gridUnit * 3
}

panel.addWidget("org.kde.plasma.lock_logout")
var pager = panel.addWidget("org.kde.plasma.pager")
pager.currentConfigGroup = ["General"]
pager.writeConfig("showWindowIcons", "true")

//var kicker = panel.addWidget("org.kde.plasma.kicker")
//kicker.currentConfigGroup = ["Shortcuts"]
//kicker.writeConfig("global", "Alt+F1")
//favorites=systemsettings.desktop,org.kde.dolphin.desktop,doublecmd-qt.desktop,preferred://browser,libreoffice-startcenter.desktop,libreoffice-writer.desktop,blackPanther-popcorntimece.desktop,blackPanther-skype.desktop

var appMenu = panel.addWidget("org.kde.plasma.kickoff")
appMenu.currentConfigGroup = ["Shortcuts"]
appMenu.writeConfig("global", "Alt+F1")
appMenu.currentConfigGroup = ["General"]
appMenu.writeConfig("favorites", [
    'systemsettings.desktop',
    'org.kde.dolphin.desktop',
    'doublecmd-qt.desktop',
    'preferred://browser',
    'libreoffice-startcenter.desktop',
    'libreoffice-writer.desktop',
    'blackPanther-popcorntimece.desktop',
    'blackPanther-skype.desktop',
].join(','))
    
// for kicker
//favoriteApps=preferred://browser,systemsettings.desktop,org.kde.dolphin.desktop,doublecmd-qt.desktop,gimp.desktop,steam.desktop,libreoffice-startcenter.desktop,libreoffice-writer.desktop,libreoffice-calc.desktop,org.kde.kate.desktop
/* var appMenu = panel.addWidget("org.kde.plasma.kickker")
kicker.currentConfigGroup = ["General"]
kicker.writeConfig("favoriteApps", [
    'preferred://browser',
    'systemsettings.desktop',
    'org.kde.dolphin.desktop',
    'doublecmd-qt.desktop',
    'gimp.desktop',
    'steam.desktop',
    'libreoffice-startcenter.desktop',
    'libreoffice-writer.desktop',
    'libreoffice-calc.desktop',
    'org.kde.kate.desktop',
].join(','))
*/
panel.addWidget("org.kde.plasma.showActivityManager")

var iconDolphin = panel.addWidget("org.kde.plasma.icon")
iconDolphin.writeConfig("url","file:///usr/share/applications/org.kde.dolphin.desktop");

var iconChromium = panel.addWidget("org.kde.plasma.icon")
iconChromium.writeConfig("url","file:///usr/share/applications/chromium-browser.desktop");

var iconSystemSettings = panel.addWidget("org.kde.plasma.icon")
iconSystemSettings.writeConfig("url","file:///usr/share/applications/systemsettings.desktop");

//panel.addWidget("org.kde.plasma.taskmanager")
var tasks = panel.addWidget("org.kde.plasma.taskmanager")
tasks.currentConfigGroup = ["General"]
tasks.writeConfig("groupingStrategy", "0")
tasks.writeConfig("maxStripes", "1")
tasks.writeConfig("showOnlyCurrentActivity", "true")
tasks.writeConfig("showOnlyCurrentDesktop", "false")
tasks.writeConfig("sortingStrategy", "1")

/* Next up is determining whether to add the Input Method Panel
 * widget to the panel or not. This is done based on whether
 * the system locale's language id is a member of the following
 * white list of languages which are known to pull in one of
 * our supported IME backends when chosen during installation
 * of common distributions. */

var langIds = ["as",    // Assamese
               "bn",    // Bengali
               "bo",    // Tibetan
               "brx",   // Bodo
               "doi",   // Dogri
               "gu",    // Gujarati
               "hi",    // Hindi
               "ja",    // Japanese
               "kn",    // Kannada
               "ko",    // Korean
               "kok",   // Konkani
               "ks",    // Kashmiri
               "lep",   // Lepcha
               "mai",   // Maithili
               "ml",    // Malayalam
               "mni",   // Manipuri
               "mr",    // Marathi
               "ne",    // Nepali
               "or",    // Odia
               "pa",    // Punjabi
               "sa",    // Sanskrit
               "sat",   // Santali
               "sd",    // Sindhi
               "si",    // Sinhala
               "ta",    // Tamil
               "te",    // Telugu
               "th",    // Thai
               "ur",    // Urdu
               "vi",    // Vietnamese
               "zh_CN", // Simplified Chinese
               "zh_TW"] // Traditional Chinese

if (langIds.indexOf(languageId) != -1) {
    panel.addWidget("org.kde.plasma.kimpanel");
}

panel.addWidget("org.kde.plasma.systemtray")
panel.addWidget("org.kde.plasma.digitalclock")
panel.addWidget("org.kde.plasma.showdesktop")
